interface IWebComponent {
    attributeChangedCallback: any;
    connectedCallback: any;
    definePublicMethods: any;
    init: any;
    render: any;
    template: any;
}
export declare class BaseWebComponent extends HTMLElement implements IWebComponent {
    data: any;
    el: HTMLElement;
    htmlTemplate: any;
    imports: string;
    root: any;
    state: any;
    sharedState: any;
    dataJson: any;
    currentState: any;
    styles: string;
    _template: any;
    constructor();
    init(): Promise<void>;
    render(): void;
    definePublicMethods(): void;
    remove(): void;
    attributeChangedCallback(name: any, oldVal: any, newVal: any): void;
    connectedCallback(): void;
    readonly template: any;
    declareProp(propName: any, getFn: any, setFn: any): void;
    dispatch(eventName: any, detail: any): void;
    setState(state: any): void;
    getState(key: any): any;
    removeState(key: any): void;
    setData(object: any, extend: any): void;
    getData(): any;
    preRender(): void;
    isJson(jsonString: any): any;
    kebabToLowerCamelCase(str: any): any;
}
export {};
